<template>
  <section>
    <v-container>
      <!-- <div class="d-flex justify-space-between flex-lg-row flex-column my-4">
          <div>
            <p>
              {{ $t("all_categories") }}
  
              <v-app-bar-nav-icon variant="text" />
            </p>
          </div>
          <div class="d-flex justify-space-between">
            <p class="mx-2">عن الموقع</p>
            <p class="mx-2">أخر الاخبار</p>
            <p class="mx-2">تواصل معنا</p>
          </div>
        </div> -->
      <div class="mb-6">
        <p>{{ $t("home") }} > {{ $t("products") }}</p>
      </div>
      <v-row>
        <v-col cols="12" lg="12">
          <row class="d-flex justify-space-between flex-lg-row flex-column">
            <v-col lg="3">
              <p class="font-weight-bold">
                {{ $t("products") }}
              </p>
            </v-col>

            <v-col lg="4">
              <div class="d-flex">
                <!-- <SharedInputSelect
                    :items="items"
                    variant="outlined"
                    rounded="lg"
                    hide-details
                    base-color="#9C96A1"
                    color="rgba(156, 150, 161, 1.0)"
                    density="comfortable"
                    item-value="id"
                    item-title="name"
                    :form="form"
                    name="rate"
                    class="mx-3"
                  /> -->
                <!-- 
                  <SharedInputSelect
                    :items="pages"
                    variant="outlined"
                    rounded="lg"
                    hide-details
                    base-color="#9C96A1"
                    color="rgba(156, 150, 161, 1.0)"
                    density="comfortable"
                    item-value="id"
                    item-title="name"
                    :form="form"
                    name="page"
                  /> -->
              </div>
            </v-col>
          </row>

          <div v-if="!loading">
            <v-row v-if="products.length">
              <v-col
                cols="6"
                lg="3"
                md="4"
                sm="6"
                v-for="product in products"
                :key="product.id"
              >
                <SharedCardsProduct :item="product" />
              </v-col>
            </v-row>

            <div v-else class="no-results">
              <v-alert type="warning"> {{ $t("no_results_founded") }}</v-alert>
            </div>

            <SharedPagination @change="getProducts" :config="config" />
          </div>
          <div class="loading d-flex justify-center align-center" v-else>
            <SharedLoading class="mt-n16" />
          </div>
        </v-col>
      </v-row>
    </v-container>
  </section>
</template>

<script setup>
import { useRoute } from "vue-router";
const route = useRoute();

const form = ref({
  categories: [],
});

const options = ref({
  categories: [400, 600],
});

const config = reactive({});
const products = ref({});

const { get, loading } = useApi();

const paginateConfig = (data) => {
  Object.assign(config, data);
};

const getProducts = async (current_page = 1) => {

 const params = new URLSearchParams();

  for (const key in form.value) {
    if (form.value.hasOwnProperty(key)) {
      const value = form.value[key];
      if (key == "categories") {
        value.forEach((item) => {
          params.append(`${key}[]`, item);
        });
      }
    }
  }

  params.append("page", current_page);

  let response = await get(`products`, params);
  products.value = response.data.data;
  paginateConfig(response.data);
};

const getOptions = async () => {
  let response = await get("products-options");
  let filters = response.data;
  options.value.categories = filters.categories;

  let categories = options.value.categories.find((element) => {
    return element.id == route.params.id;
  });

  if (categories) {
    categories.sub_categories.forEach((child) => {
      form.value.categories.push(child.id);
    });
  }

 

  getProducts(1);
};

// const checkedParent = (children, category) => {

// };

onMounted(() => {
  getOptions();
});
</script>
